Attribute VB_Name = "SupInp"
'Support File Interpreter
'========================
'The format is very unpredictable and can't be broken down into
'basic building blocks.
'But.. it does the job.
'I tried a more structured approach, but the result was structuredness
'which compromized user-friendliness.

Option Explicit
DefLng A-Z

'Private FileBuf As String
'Private FileBufSize As Long
'Private FileBufPtr As Long

Private SupfBuf As clsTxtParser

Private Preset_Name() As String
Private Preset_Data() As String
Private Preset_last As Long

Private CHR_info_defined As Boolean
Private CHR_info() As Long
Private CHR_info_ptr As Long
Private Bank_CHR_info_ptr() As Long

'Takes care of loading graphics for a sprite, as determined by the
'support .TXT file.
Public Sub Load_Sprite_Patterns()
Dim a, b, c, d

If CHR_info_defined = False Then Exit Sub

CHR_info_ptr = Bank_CHR_info_ptr(BankPtrSelect)
If CHR_info_ptr = -1 Then Exit Sub

While (CHR_info_get >= 0) And (CHR_info_ok)
    a = CHR_info_get_move
    b = CHR_info_get_move
    c = CHR_info_get_move
    If (Sprite >= a) And (Sprite <= b) Then
        While (CHR_info_get >= 0) And (CHR_info_ok)
            a = CHR_info_get_move
            b = CHR_info_get_move
            c = CHR_info_get_move
            For d = 0 To (c - 1)
                If (b >= 0) And (b <= &HFFF) Then
                    PatternMap(b + d) = a + d
                End If
            Next d
        Wend
        CHR_info_ptr = CHR_info_ptr + 1
    Else
        CHR_info_ptr = CHR_info_ptr + c
    End If
Wend
End Sub

Public Sub load(filename As String)
Dim chr_info_backup_ptr
Dim a, b, c
Dim stra As String, strb As String
Dim ca As String * 1

Set SupfBuf = New clsTxtParser

SupfBuf.load_file filename

For a = 0 To &HFFF
PatternMap(a) = a + &H10
Next a

CHR_info_ptr = 0

Preset_last = -1

BankReg_last = -1
BankPtrSelect = 0

BankPtr(2) = &H7C010

DataBank = 0
SprPtrBank = 0
FramePtrBank = 0
CoordPtrBank = 0

'BaseData = 0
'BaseDataSz = &H3800
BaseSprLo = &H3E00
BaseSprHi = &H3F00
BaseFrameLo = &H3800
BaseFrameHi = &H3A00
BaseCoordLo = &H3C00
BaseCoordHi = &H3D00

DataMovable = 0

DataSegLast = -1
PtrSegLast = -1

CoordPointerAdd = 0
FramePointerAdd = 0
FrameTileNumofBase = 0
FramePageMethod = 0
CoordinateBankSelect = 0
CoordPairs = 0
DataParseSensitive = 1

ResetAll_Enabled = False

Sprite = 0
MaxSprite = &HFF

While (SupfBuf.ok)
    SupfBuf.seek_symbol
    stra = LCase(SupfBuf.getstring)
    Select Case stra
    Case "banks"
        SupfBuf.seek_symbol
        SupfBuf.move 1
        SupfBuf.seek_symbol
        While (Not SupfBuf.getc = "}") And (SupfBuf.ok)
            stra = SupfBuf.gets_until_chars(",} ")
            BankReg_last = BankReg_last + 1
            ReDim Preserve BankReg(BankReg_last)
            BankReg(BankReg_last) = dec(stra)
            ca = SupfBuf.getc
            If (ca = ",") Then
                SupfBuf.move 1
            End If
            SupfBuf.seek_symbol
        Wend
        SupfBuf.move 1
    Case "pattern_load"
        SupfBuf.seek_symbol
        SupfBuf.move 1
        SupfBuf.seek_symbol
        a = 0
        While (Not SupfBuf.getc = "}") And (SupfBuf.ok)
            stra = SupfBuf.gets_until_chars(",} ")
            c = dec(stra)
            If (a < &H10) Then
                For b = 0 To &HFF
                    PatternMap((a * &H100) + b) = c + b
                Next b
            End If
            a = a + 1
            ca = SupfBuf.getc
            If (ca = ",") Then
                SupfBuf.move 1
            End If
            SupfBuf.seek_symbol
        Wend
        SupfBuf.move 1
    Case "spr_pal"
        SupfBuf.seek_symbol
        SupfBuf.move 1
        SupfBuf.seek_symbol
        a = 0
        While (Not SupfBuf.getc = "}") And (SupfBuf.ok)
            stra = SupfBuf.gets_until_chars(",} ")
            If (a < &H10) Then
                SprPal(a) = dec(stra)
            End If
            a = a + 1
            ca = SupfBuf.getc
            If (ca = ",") Then
                SupfBuf.move 1
            End If
            SupfBuf.seek_symbol
        Wend
        SupfBuf.move 1
    Case "chr_info"
        CHR_info_defined = True
        ReDim Bank_CHR_info_ptr(BankReg_last)
        For a = 0 To BankReg_last
            Bank_CHR_info_ptr(a) = -1
        Next a
        SupfBuf.seek_symbol
        SupfBuf.move 1
        SupfBuf.seek_symbol
        While (Not SupfBuf.getc = "}") And (SupfBuf.ok)
            stra = LCase(SupfBuf.getstring)
            Select Case stra
            Case "presets"
                SupfBuf.seek_symbol
                SupfBuf.move 1
                SupfBuf.seek_symbol
                While (Not SupfBuf.getc = "}") And (SupfBuf.ok)
                    stra = SupfBuf.getstring
                    SupfBuf.seek_symbol
                    SupfBuf.move 1
                    SupfBuf.seek_symbol
                    strb = SupfBuf.gets_until_chars("}")
                    SupfBuf.move 1
                    Preset_last = Preset_last + 1
                    ReDim Preserve Preset_Name(Preset_last)
                    ReDim Preserve Preset_Data(Preset_last)
                    Preset_Name(Preset_last) = LCase(stra)
                    Preset_Data(Preset_last) = strb
                    SupfBuf.seek_symbol
                Wend
                SupfBuf.move 1
            Case "bank"
                SupfBuf.seek_symbol
                stra = SupfBuf.getstring
                a = Get_BankReg_Index(dec(stra))
                If (a >= 0) Then
                    Bank_CHR_info_ptr(a) = CHR_info_ptr
                    SupfBuf.seek_symbol
                    SupfBuf.move 1
                    SupfBuf.seek_symbol
                    While (Not SupfBuf.getc = "}") And (SupfBuf.ok)
                        If (SupfBuf.getc) = ">" Then
                            SupfBuf.move 1
                        Else
                            stra = SupfBuf.gets_until_chars(",")
                            a = InStr(1, stra, "-")
                            If (a > 1) Then
                                b = dec(Mid(stra, 1, a - 1))
                                c = dec(Right(stra, Len(stra) - a))
                            Else
                                b = dec(stra)
                                c = b
                            End If
                            CHR_info_add b
                            CHR_info_add c
                            chr_info_backup_ptr = CHR_info_ptr
                            CHR_info_add 0
                            SupfBuf.move 1
                            SupfBuf.seek_symbol
                            If SupfBuf.getc = "{" Then
                                SupfBuf.move 1
                                stra = SupfBuf.gets_until_chars("}")
                                Interpret_CHR_info_block (stra)
                                SupfBuf.move 1
                            Else
                                stra = LCase(SupfBuf.getstring)
                                For a = 0 To Preset_last
                                    If stra = Preset_Name(a) Then
                                        Exit For
                                    End If
                                Next a
                                Interpret_CHR_info_block (Preset_Data(a))
                            End If
                            a = (CHR_info_ptr - chr_info_backup_ptr) - 1
                            CHR_info_set_at chr_info_backup_ptr, a
                        End If
                        SupfBuf.seek_symbol
                    Wend
                    CHR_info_add -1
                    SupfBuf.move 1
                End If
            End Select
            SupfBuf.seek_symbol
        Wend
        SupfBuf.move 1
    Case "datasegs"
        DataSegLast = -1
        SupfBuf.seek_symbol
        SupfBuf.move 1
        SupfBuf.seek_symbol
        While (Not SupfBuf.getc = "}") And (SupfBuf.ok)
            If (SupfBuf.getc) = ">" Then
                SupfBuf.move 1
                SupfBuf.seek_symbol
                DataSegLast = DataSegLast + 1
                ReDim Preserve DataSegs(DataSegLast)
                While (Not SupfBuf.getc = "}") And (Not SupfBuf.getc = ">") And (SupfBuf.ok)
                    stra = SupfBuf.getstring
                    Select Case stra
                    Case "start"
                        DataSegs(DataSegLast).Start = Get_Value
                    Case "end"
                        DataSegs(DataSegLast).End = Get_Value
                    End Select
                    SupfBuf.seek_symbol
                Wend
            Else
                SupfBuf.move 1  'Prevent freeze on typos
            End If
        Wend
        SupfBuf.move 1
    Case "ptrsegs"
        PtrSegLast = -1
        SupfBuf.seek_symbol
        SupfBuf.move 1
        SupfBuf.seek_symbol
        While (Not SupfBuf.getc = "}") And (SupfBuf.ok)
            If (SupfBuf.getc) = ">" Then
                SupfBuf.move 1
                SupfBuf.seek_symbol
                PtrSegLast = PtrSegLast + 1
                ReDim Preserve PtrSegs(PtrSegLast)
                While (Not SupfBuf.getc = "}") And (Not SupfBuf.getc = ">") And (SupfBuf.ok)
                    stra = SupfBuf.getstring
                    Select Case stra
                    Case "lo_ptr"
                        PtrSegs(PtrSegLast).loptr = Get_Value
                    Case "hi_ptr"
                        PtrSegs(PtrSegLast).hiptr = Get_Value
                    Case "entries"
                        PtrSegs(PtrSegLast).entries = Get_Value
                    End Select
                    SupfBuf.seek_symbol
                Wend
            Else
                SupfBuf.move 1  'Prevent freeze on typos
            End If
        Wend
        SupfBuf.move 1
    Case "first_bank"
        a = Get_Value
        a = Get_BankReg_Index(a)
        If (a >= 0) Then
            BankPtrSelect = a
        End If
        
    Case "coordbank0": CoordBankReg(0) = Get_Value
    Case "coordbank1": CoordBankReg(1) = Get_Value

    Case "hard_bank": BankPtr(2) = Get_Value
    
    Case "databank": DataBank = Get_Value
    Case "sprptrbank": SprPtrBank = Get_Value
    Case "frameptrbank": FramePtrBank = Get_Value
    Case "coordptrbank": CoordPtrBank = Get_Value
    
    Case "basedata": a = Get_Value
    Case "basedatasz": a = Get_Value
    Case "basesprlo": BaseSprLo = Get_Value
    Case "basesprhi": BaseSprHi = Get_Value
    Case "baseframelo": BaseFrameLo = Get_Value
    Case "baseframehi": BaseFrameHi = Get_Value
    Case "basecoordlo": BaseCoordLo = Get_Value
    Case "basecoordhi": BaseCoordHi = Get_Value
    
    Case "datamovable": DataMovable = Get_Value
    
    Case "coordpointeradd": CoordPointerAdd = Get_Value
    Case "framepointeradd": FramePointerAdd = Get_Value
    Case "frametilenumofbase": FrameTileNumofBase = Get_Value
    Case "framepagemethod": FramePageMethod = Get_Value
    Case "coordinatebankselect": CoordinateBankSelect = Get_Value
    Case "coordpairs": CoordPairs = Get_Value
    Case "dataparsesensitive": DataParseSensitive = Get_Value
    
    Case "reset"
        ResetAll_Enabled = True
        SupfBuf.seek_symbol
        SupfBuf.move 1
        SupfBuf.seek_symbol
        ResetAreas = -1
        While (Not SupfBuf.getc = "}") And (SupfBuf.ok)
            ResetAreas = ResetAreas + 1
            ReDim Preserve ResetArea_Start(ResetAreas)
            ReDim Preserve ResetArea_Size(ResetAreas)
            ResetArea_Start(ResetAreas) = Get_Value_Plain
            SupfBuf.seek_symbol
            ResetArea_Size(ResetAreas) = Get_Value_Plain
            SupfBuf.seek_symbol
        Wend
        SupfBuf.move 1

    Case "start_sprite": Sprite = Get_Value
    Case "max_sprite": MaxSprite = Get_Value
    End Select
Wend
End Sub

Private Sub Interpret_CHR_info_block(block As String)
Dim tmpTP As clsTxtParser
Dim stra As String

Set tmpTP = New clsTxtParser

tmpTP.load_string block

tmpTP.seek_symbol

While (tmpTP.ok And Not (tmpTP.getc = "}"))
If tmpTP.getc = ">" Then
    tmpTP.move 1
Else
    stra = tmpTP.gets_until_chars(", }>")
    CHR_info_add dec(stra)
    If tmpTP.getc = "," Then
        tmpTP.move 1
    End If
End If
tmpTP.seek_symbol
Wend
CHR_info_add -1
End Sub

Private Sub CHR_info_add(valu As Long)
ReDim Preserve CHR_info(CHR_info_ptr)
CHR_info(CHR_info_ptr) = valu
CHR_info_ptr = CHR_info_ptr + 1
End Sub

Private Sub CHR_info_set_at(ptr As Long, valu As Long)
CHR_info(ptr) = valu
End Sub

Private Function CHR_info_get_move() As Long
If (CHR_info_ptr <= UBound(CHR_info)) Then
    CHR_info_get_move = CHR_info(CHR_info_ptr)
    CHR_info_ptr = CHR_info_ptr + 1
End If
End Function

Private Function CHR_info_get() As Long
If (CHR_info_ptr <= UBound(CHR_info)) Then
    CHR_info_get = CHR_info(CHR_info_ptr)
End If
End Function

Private Function CHR_info_ok() As Boolean
CHR_info_ok = True
If (CHR_info_ptr > UBound(CHR_info)) Then
    CHR_info_ok = False
End If
End Function

Private Function Get_Value() As Long
Dim stra As String
SupfBuf.seek_symbol
SupfBuf.move 1
SupfBuf.seek_symbol
stra = SupfBuf.gets_until_chars(", " + Chr(&HD) + Chr(&HA))
If SupfBuf.getc = "," Then
    SupfBuf.move 1
End If
Get_Value = dec(stra)
End Function

Private Function Get_Value_Plain() As Long
Dim stra As String
stra = SupfBuf.gets_until_chars(", " + Chr(&HD) + Chr(&HA))
If SupfBuf.getc = "," Then
    SupfBuf.move 1
End If
Get_Value_Plain = dec(stra)
End Function
