Attribute VB_Name = "Common"
Option Explicit
DefLng A-Z

Private CfgFile As String

Public cfgID(255) As String
Public cfgv(255) As Variant
Public cfgtype(255) As Byte
Public cidc As Byte

'Make a decimal value out a hexidecimal value
Function dec(hexstr As String) As Long
Dim hexchar As String * 1
Dim sendstring As String
Dim a, hexcharasc

sendstring = "&H"
For a = 1 To Len(hexstr)
    hexchar = Mid(hexstr, a, 1)
    hexcharasc = Asc(hexchar)
    If (hexcharasc < &H30) Then GoTo nextchar
    If (hexcharasc > &H39) And (hexcharasc < &H41) Then GoTo nextchar
    If (hexcharasc > &H46) And (hexcharasc < &H61) Then GoTo nextchar
    If (hexcharasc > &H66) Then GoTo nextchar
    sendstring = sendstring + hexchar
nextchar:
Next a
If Not sendstring = "&H" Then
    dec = CLng(sendstring)
Else
    dec = 0
End If
End Function

Public Sub LoadCfg(file As String)
Dim tint As Integer
Dim tstr As String
Dim PathBackup As String
Dim t1 As String * 1

PathBackup = CurDir
ChDir App.Path
CfgFile = file

Open CfgFile For Binary As #1
cfgl:
Do
Get #1, , t1
If t1 = "=" Then GoTo cfgeq
If t1 = "/" Then GoTo cfge
cfgID(cidc) = cfgID(cidc) + t1
Loop Until EOF(1)
GoTo cfge
cfgeq:
Get #1, , t1
Select Case t1
Case "#"
    cfgtype(cidc) = 0
    tstr = ""
    Do
        Get #1, , t1
        If t1 = ";" Then
            cfgv(cidc) = val(tstr)
            cidc = cidc + 1
            Get #1, , tint
            GoTo cfgl
        End If
        tstr = tstr + t1
    Loop Until EOF(1)
Case sse
    cfgtype(cidc) = 1
    tstr = ""
    Do
        Get #1, , t1
        If t1 = sse Then
            cfgv(cidc) = tstr
            cidc = cidc + 1
            Get #1, , tint
            GoTo cfgl
        End If
        tstr = tstr + t1
    Loop Until EOF(1)
End Select
cfge:
Close #1

ChDir PathBackup
End Sub

Public Sub SetCfg(id As String, val As Variant)
Dim PathBackup As String
Dim a
PathBackup = CurDir()
ChDir App.Path

a = 0
Do
If cfgID(a) = id Then cfgv(a) = val: GoTo savecfg
a = a + 1
Loop Until a = cidc
MsgBox "Cant set config ID: " + id
GoTo revert_path
savecfg:

Open CfgFile For Output As #1
For a = 0 To (cidc - 1)
Select Case cfgtype(a)
Case 0: Print #1, cfgID(a) + "=#" + CStr(cfgv(a)) + ";"
Case 1: Print #1, cfgID(a) + "=" + sse + cfgv(a) + sse
End Select
Next a
Print #1, "/"
Close #1

revert_path:
ChDir PathBackup
End Sub


Public Function GetCfg(id As String) As Variant
Dim a
Do
If cfgID(a) = id Then
    GetCfg = cfgv(a)
    Exit Function
End If
a = a + 1
Loop Until a = cidc
MsgBox "Cant find config ID: " + id
End Function

Public Function sse() As String
sse = Chr(&H22)
End Function

Public Function VWidth(inv, min, max)
If inv < min Then inv = min
If inv > max Then inv = max
VWidth = inv
End Function

Public Function Wrap(inv, min, max)
Dim a
If inv < min Then
    a = (max - min) + 1
    While (inv < min)
        inv = inv + a
    Wend
ElseIf inv > max Then
    a = (max - min) + 1
    While (inv > max)
        inv = inv - a
    Wend
End If
Wrap = inv
End Function

Public Function RGBmirr(col)
RGBmirr = RGB(Int(col / 65536) And 255, Int(col / 256) And 255, col And 255)
End Function

Public Sub SetTBCool(tb As TextBox, text As String)
Dim spos
tb.Tag = ":)"   'disable tb_Change routine's action by using .Tag
spos = tb.SelStart
If LenB(tb.text) = 0 Then spos = 1
tb.text = text      'set
tb.SelStart = spos     'restore current cursor position
tb.Tag = vbNullString     're-enable tb_Change
End Sub

Public Sub SetOptCool(opt As OptionButton, oval As Boolean)
opt.Tag = ":)"
opt.value = oval
opt.Tag = vbNullString
End Sub

Public Sub SetCheckCool(check As CheckBox, val As Byte)
check.Tag = ":)"
check.value = val
check.Tag = vbNullString
End Sub

Public Sub SetListCool(list As ListBox, val)
list.Tag = ":)"
list.ListIndex = val
list.Tag = vbNullString
End Sub

Public Sub SetComboCool(combo As ComboBox, val As Variant)
combo.Tag = ":)"
combo.ListIndex = val
combo.Tag = vbNullString
End Sub

